package com.gingersoft.gsa.cloud.table.mvp.contract;

import android.app.Activity;

import com.gingersoft.gsa.cloud.database.bean.ComboItem;
import com.gingersoft.gsa.cloud.database.bean.Food;
import com.gingersoft.gsa.cloud.database.bean.FoodCombo;
import com.gingersoft.gsa.cloud.database.bean.FoodModifier;
import com.gingersoft.gsa.cloud.database.bean.Modifier;
import com.gingersoft.gsa.cloud.table.mvp.ui.activity.MealStandActivity;
import com.jess.arms.mvp.IView;
import com.jess.arms.mvp.IModel;

import java.util.List;

import javax.inject.Inject;
import javax.inject.Named;

import io.reactivex.Single;


/**
 * ================================================
 * Description:
 * <p>
 * Created by MVPArmsTemplate on 04/17/2021 10:40
 * <a href="mailto:jess.yan.effort@gmail.com">Contact me</a>
 * <a href="https://github.com/JessYanCoding">Follow me</a>
 * <a href="https://github.com/JessYanCoding/MVPArms">Star me</a>
 * <a href="https://github.com/JessYanCoding/MVPArms/wiki">See me</a>
 * <a href="https://github.com/JessYanCoding/MVPArmsTemplate">模版请保持更新</a>
 * ================================================
 */
public interface SetMealContract {
    //对于经常使用的关于UI的方法可以定义到IView中,如显示隐藏进度条,和显示文字消息
    interface View extends BaseOrderContract.View {

        void setFoodGroupRecycleSpanCount(int size);

        void setFoodRecycleSpanCount(int size);

        void setComboRecycleSpanCount(int size);

        void setModifierRecycleSpanCount(int size);

        void showViewModeVisibility(int... viewMode);

        void showModifyLayoutVisibility(boolean show);

        void showBtnMealModifyRestoreVisibility(boolean show);

        void setOrderFoodCount(String number);

        int getCurrentViewMode();

        void setPluMode();

        void resetPluMode();

        void setMealRvScrollToPosition(int position);

        void returnFoodGroupList(List<Food> foodGroupList);

        void returnFoodList(List<Food> foodList);

        void returnFoodComboList(List<ComboItem> comboList);

        void returnModifierList(List<Modifier> modifierList);

        MealStandActivity getActivity2();

        int getFromType();
    }

    //Model层定义接口,外部只需关心Model返回的数据,无需关心内部细节,即是否使用缓存
    interface Model extends BaseOrderContract.Model {

        Single<List<Food>> queryDB_FoodGroupList(int foodSummary);

        Single<List<Food>> queryDB_FoodList(long parentId, int foodSummary);

        Single<List<Modifier>> queryDB_ModifierList(long fid, int mode);

        Single<List<ComboItem>> queryDB_ComboList(long fid, int foodSummary);

        Single<List<FoodCombo>> isComboFood(long fid);

        Single<List<FoodModifier>> queryDB_FoodModifierList(long fid);
    }




}
